{# Helpers #}
{% macro directory_path(dir, domain) %}
  {%- if dir.destination -%}
    {{ dir.destination|nginx_escape }}
  {%- else -%}
    /var/www/{{ domain }}
  {%- endif -%}
{% endmacro %}

{% macro rewrite_flags(rule) -%}
  {%- if rule.last -%}
    last
  {%- endif -%}
{% endmacro -%}

{# Path renderers #}
{% macro render_directory(dir, domain) %}
  root {{ directory_path(dir, domain) }};

  {%- if dir.index -%}
    autoindex on;
  {% endif %}
{%- endmacro -%}

{% macro render_proxy(proxy) %}
  proxy_pass {{ proxy.url }};
{% endmacro %}

{% macro render_redirect(redirect) %}
  return {{ redirect.http_status }} {{ redirect.destination|nginx_escape(redirect.escape) }};
{% endmacro %}

{# Main renderer #}
{% macro render_path(path_obj, domain=None) -%}
  location {{ path_obj.path }} {
    {%- if path_obj.directory -%}
      {{ render_directory(path_obj.directory, domain) }}
    {%- elif path_obj.proxy -%}
      {{ render_proxy(path_obj.proxy) }}
    {%- elif path_obj.redirect -%}
      {{ render_redirect(path_obj.redirect) }}
    {%- elif path_obj.http_status -%}
      return {{ path_obj.http_status }};
    {%- endif -%}

    {%- for rule in path_obj.rewrite_rules -%}
      rewrite {{ rule.source }} {{ rule.destination }} {{ rewrite_flags(rule) }};
    {%- endfor -%}
  }
{% endmacro %}
